



<!DOCTYPE html><html lang=zh-CN><head><meta http-equiv="Content-Type" content="text/html; charset=utf-8" /><meta http-equiv="X-UA-Compatible" content="IE=edge,chrome=1"><meta name="applicable-device" content="pc,mobile"><meta name="renderer" content="webkit"><meta name="viewport" content="width=device-width,initial-scale=1.0,maximum-scale=5,viewport-fit=cover">
<title>[转]使用ADO.NET访问Oracle存储过程</title>	
<script src="//n4.ikafan.com/assets/run_prettify.js?ac"></script>
<link rel="stylesheet" href="//n4.ikafan.com/assetsg/style.css">
<!-- <link rel="stylesheet" href="//pic.ikafan.com/staticx/shuzhiduo/1/css.grace/fontello.css?ac"> -->
<!-- <link rel="stylesheet" href="//pic.ikafan.com/staticx/shuzhiduo/1/css.grace/animation.css?ac"> -->
<script>
var _hmt = _hmt || [];
(function() {
  var hm = document.createElement("script");
  hm.src = "https://hm.baidu.com/hm.js?c61d51e9fdcf1d1631ddfce8df9cd119";
  var s = document.getElementsByTagName("script")[0]; 
  s.parentNode.insertBefore(hm, s);
})();
</script>
<script src="https://n4.ikafan.com/g/show.js"></script>

</head>
<div id="header" class="navbar navbar-default navbar-fixed-top header-01">
	<div class="container">
		<h1 class="logo">
			<a  href="/" title="巴特西"/>
							巴特西
			</a>
		</h1>
				<div role="navigation"  class="site-nav  primary-menu">
			<div class="menu-fix-box">
				 <ul id="menu-navigation" class="menu" >
<li><a href="/">首页</a></li>
<!-- <li><a href="/search/Hadoop/">Hadoop</a></li>
<li><a href="/search/Linux/">Linux</a></li>
<li><a href="/search/jQuery/">jQuery</a></li> -->
<li><a href="/search/Python/">Python</a></li>
<li><a href="/search/Java/">Java</a></li>
<li><a href="/search/PHP/">PHP</a></li>
<li><a href="/search/IOS/">IOS</a></li>
<li><a href="/search/Andorid/">Andorid</a></li>
<li><a href="/search/NodeJS/">NodeJS</a></li>
<li><a href="/search/JavaScript/">JavaScript</a></li>
<li><a href="/search/HTML5/">HTML5</a></li>
				</ul>					 			
			</div>
		</div>
				<!--<div class="right-nav">
				<button class="js-toggle-search"><i class="icon-search"></i></button>
		</div>-->
       
			</div>	
</div>

<div id="page-content">
	<div class="container">
		<div class="row">
			
			<div class="blog-post">
								<!--<div class="posts-top-cjtz clearfix"></div>-->
								<div class="post">
										<div class="post-title">
											<div id="title_top"></div>
<script>insertAdIfNeeded();</script>
						<h1 class="title">[转]使用ADO.NET访问Oracle存储过程</h1>
						<div class="post_icon">
							<span class="icon-clock-1"> 2024-02-20 14:59:19 </span>
						</div>
										<div class="post-content">
											
		<p>本文转自：<a href="http://www.cnblogs.com/datasky/archive/2007/11/07/952141.html" rel="external nofollow noreferrer">http://www.cnblogs.com/datasky/archive/2007/11/07/952141.html</a></p>
<p>本文讨论了如何使用 ADO.NET 访问 Oracle 存储过程（称为 SQL 编程块）和函数（返回单个值的编程块）。</p>
<p>您可以使用以下托管数据提供程序连接到 Oracle 数据库：Microsoft .NET Oracle 提供程序、OLE DB .NET 提供程序、ODBC .NET 数据提供程序以及 Oracle 的 ODP.NET 提供程序。本文使用用于 Oracle 的 Microsoft .NET 框架数据提供程序。使用 Oracle ODP.NET 数据提供程序或用于 OLE DB 的 Microsoft .NET 框架数据提供程序时可使用不同的功能。</p>
<p>Oracle .NET 数据提供程序随 .NET 框架 1.1/2.0 一起提供。如果您使用的是 .NET 框架 1.0，您将需要下载 .NET Managed Provider for Oracle。无论是哪个版本，数据提供程序类都位于 System.Data.OracleClient 命名空间中。</p>
<h4>概述</h4>
<p>PL/SQL 是 SQL 的 Oracle 实现。它与 Microsoft?SQL Server? 所使用的 T-SQL 类似，但也有一些不同之处，本文稍后对此进行了详细讨论。与 T-SQL 一样，PL/SQL 扩展了标准 SQL。PL/SQL 用于定义命名编程块，如存储过程、函数和触发器。</p>
<h4>类</h4>
<p>可使用 System.Data.OracleClient 命名空间中类的子集来执行 Oracle 存储过程和函数。下表对这些类进行了说明：</p>
<p>类 说明</p>
<p>OracleCommand</p>
<p>针对 Oracle 数据库执行的存储过程的 SQL 语句。</p>
<p>OracleConnection</p>
<p>打开的数据库连接。</p>
<p>OracleParameter</p>
<p>OracleCommand 的参数，也可能是它到 DataColumn 的映射。</p>
<p>OracleParameterCollection</p>
<p>OracleParameter 对象的集合。</p>
<p>OracleType</p>
<p>Oracle 数据类型和结构的枚举。</p>
<h4>执行存储过程</h4>
<p>执行 Oracle 存储过程与执行 SQL Server 存储过程类似。下面的步骤说明了如何执行 Oracle 存储过程和检索它返回的结果。</p>
<p>1.</p>
<p>在 HR 架构中创建一个名为 COUNT_JOB_HISTORY 的存储过程，以计算 JOB_HISTORY 表中的记录数。</p>
<pre class="prettyprint linenums">CREATE OR REPLACE PROCEDURE COUNT_JOB_HISTORY<br />
(<br />
reccount OUT NUMBER<br />
)<br />
IS<br />
BEGIN<br />
SELECT COUNT(*) INTO reccount<br />
FROM JOB_HISTORY;<br />
END COUNT_JOB_HISTORY;
</pre>
<p>HR 架构是默认 Oracle 安装中包含的一个示例。</p>
<p>2.</p>
<p>将 System.Data.OracleClient.dll（用于 Oracle 的 Microsoft .NET 框架数据提供程序）的引用添加到项目中。</p>
<p>3.</p>
<p>使用 using 指令导入 OracleClient 类中的类型。</p>
<pre class="prettyprint linenums">using System.Data.OracleClient;
</pre>
<p>4.</p>
<p>创建一个 OracleConnection 对象。</p>
<pre class="prettyprint linenums">OracleConnection conn = new OracleConnection("Data Source=oracledb;<br />
User Id=UserID;Password=Password;");
</pre>
<p>用您的值替换 Oracle 数据库的名称、用户名和密码。</p>
<p>5.</p>
<p>创建一个 OracleCommand 对象。将其 Connection 属性设置为第 4 步中创建的连接。将其 CommandText 设置为存储过程的名称，并将其 CommandText 属性设置为 CommandType.StoredProcedure。当您调用第 8 步中介绍的一个 Execute() 方法时，该命令对象将执行指定的存储过程。</p>
<pre class="prettyprint linenums">OracleCommand cmd = new OracleCommand();<br />
cmd.Connection = conn;<br />
cmd.CommandText = "COUNT_JOB_HISTORY";<br />
cmd.CommandType = CommandType.StoredProcedure;
</pre>
<p>如果您的存储过程名称含有特殊字符，您就必须使用转义序列。您可以通过重置 CommandText 属性来重用现有的 OracleCommand 对象。</p>
<p>6.</p>
<p>创建输入、输出和返回值的 OracleParameter 对象，并将其添加到 OracleCommand 对象的参数集合中。</p>
<pre class="prettyprint linenums">cmd.Parameters.Add("reccount", OracleType.Number).Direction =<br />
ParameterDirection.Output;
</pre>
<p>该行代码是以下两行代码的简写形式：</p>
<pre class="prettyprint linenums">cmd.Parameters.Add("reccount", OracleType.Number);<br />
cmd.Parameters["reccount"].Direction = ParameterDirection.Output;
</pre>
<p>7.</p>
<p>如果您要检索结果集，请创建 DataSet、DataTable 或 DataReader。在本示例中，我们只是获取第 6 步中创建的输出参数中的计数。</p>
<p>8.</p>
<p>使用 OracleCommand 对象的一个 Execute 方法打开连接并执行存储过程，如下所示：</p>
<p>方法 说明</p>
<p>ExecuteReader</p>
<p>通过执行能够返回结果集的存储过程生成 OracleDataReader。</p>
<p>ExecuteNonQuery</p>
<p>执行不返回结果集的查询或过程，返回受影响的行数。</p>
<p>ExecuteOracleNonQuery</p>
<p>执行查询，返回受影响的行数。</p>
<p>该方法还使用 OracleString 参数来返回 UPDATE、INSERT 或 DELETE 查询所修改的最后一行的行 ID。</p>
<p>ExecuteScalar</p>
<p>执行一个查询或过程，并且返回查询或过程的返回值，或者将结果集第一行第一列的值作为 .NET 框架数据类型返回。</p>
<p>ExecuteOracleScalar</p>
<p>执行一个查询或过程，并且返回查询或过程的返回值，或者将结果集第一行第一列的值作为 OracleType 数据类型返回。</p>
<p>使用完连接后，不要忘记将其关闭。</p>
<pre class="prettyprint linenums">conn.Open();<br />
cmd.ExecuteNonQuery();<br />
conn.Close();
</pre>
<p>如果您要使用 DataAdapter 来填充 DataTable 或 DataSet，可以依靠 DataAdapter 来打开和关闭连接。</p>
<p>9.</p>
<p>处理结果。在我们的示例中，可在显示到控制台的输出参数中得到记录数：</p>
<pre class="prettyprint linenums">Console.WriteLine(cmd.Parameters["reccount"].Value);
</pre>
<p>下面是在本示例中开发的用于执行存储过程和检索结果的代码：</p>
<pre class="prettyprint linenums">OracleConnection conn = new OracleConnection("Data Source=oracledb;<br />
User Id=UserID;Password=Password;");<br />
OracleCommand cmd = new OracleCommand();<br />
cmd.Connection = conn;<br />
cmd.CommandText = "COUNT_JOB_HISTORY";<br />
cmd.CommandType = CommandType.StoredProcedure;<br />
cmd.Parameters.Add("reccount", OracleType.Number).Direction =<br />
ParameterDirection.Output;<br />
conn.Open();<br />
cmd.ExecuteNonQuery();<br />
conn.Close();<br />
Console.WriteLine(cmd.Parameters["reccount"].Value);
</pre>
<h4>不返回数据的存储过程</h4>
<p>OracleCommand 类的 ExecuteOracleNonQuery() 方法用于执行不返回任何行的 SQL 语句或存储过程。该方法返回一个 int 值，表示受 UPDATE、INSERT 和 DELETE 命令影响的行数；如果没有任何行受到影响，则返回 -1。如果您所执行的 INSERT、DELETE 或 UPDATE 语句恰好影响一行，则该方法具有单个参数 OracleString out rowid，该参数唯一标识 Oracle 数据库中受影响的行。可以使用该值来优化后续相关查询。</p>
<p>还可以使用 OracleCommand 类的 ExecuteNonQuery() 方法来执行不返回数据的存储过程，但您将无法获得上面介绍的唯一行标识符。</p>
<p>尽管上述命令都不会返回任何数据，但映射到参数的输出参数和返回值仍然使用数据进行填充。这使您可以使用上述任一命令从存储过程返回一个或多个标量值。</p>
<p>以下 Oracle 存储过程删除了由单个输入参数指定的员工的所有工作经历，并且不返回任何数据。</p>
<pre class="prettyprint linenums">CREATE OR REPLACE PROCEDURE DELETE_JOB_HISTORY<br />
(<br />
p_employee_id NUMBER<br />
)<br />
IS<br />
BEGIN<br />
DELETE FROM job_history<br />
WHERE employee_id = p_employee_id;<br />
END DELETE_JOB_HISTORY;
</pre>
<p>以下代码运行了该存储过程。</p>
<pre class="prettyprint linenums">// create the connection<br />
OracleConnection conn = new OracleConnection("Data Source=oracledb;<br />
User Id=UserID;Password=Password;");<br />
// create the command for the stored procedure<br />
OracleCommand cmd = new OracleCommand();<br />
cmd.Connection = conn;<br />
cmd.CommandText = "COUNT_JOB_HISTORY";<br />
cmd.CommandType = CommandType.StoredProcedure;<br />
// add the parameter specifying the employee for whom to delete records<br />
cmd.Parameters.Add("p_employee_id", OracleType.Number).Value = 102;<br />
OracleString rowId;<br />
// execute the stored procedure<br />
conn.Open();<br />
int rowsAffected = cmd.ExecuteNonQuery();<br />
conn.Close();<br />
Console.WriteLine("Rows affected: " + rowsAffected);
</pre>
<p>如果您尚未修改默认的 HR 安装，则 JOB_HISTORY 表中员工 102 的记录被删除，并且向控制台输出以下内容：</p>
<pre class="prettyprint linenums">Rows affected: 1
</pre>
<p>访问返回值</p>
<p>RETURN 语句立即将控制从存储过程返回到调用程序。Oracle 存储过程中的 RETURN 语句无法像在 T-SQL 中那样返回值。</p>
<p>Oracle 函数是计算并返回单个值的子程序。它们的结构类似于存储过程，不同之处在于它们总是具有必须返回值的 RETURN 子句。</p>
<p>下面是一个返回指定员工的电子邮件的函数：</p>
<pre class="prettyprint linenums">CREATE OR REPLACE FUNCTION GET_EMPLOYEE_EMAIL (<br />
p_employee_id NUMBER<br />
)<br />
RETURN VARCHAR2<br />
IS p_email VARCHAR2(25);<br />
BEGIN<br />
SELECT EMAIL INTO p_email FROM EMPLOYEES<br />
WHERE EMPLOYEE_ID = p_employee_id;<br />
RETURN p_email;<br />
END GET_EMPLOYEE_EMAIL;
</pre>
<p>执行函数的方式与执行存储过程的方式相同。可使用 ParameterDirection.ReturnValue 参数获得由函数返回的结果。以下代码显示了使用方法：</p>
<pre class="prettyprint linenums">// create the connection<br />
OracleConnection conn = new OracleConnection("Data Source=oracledb;<br />
User Id=UserID;Password=Password;");<br />
// create the command for the function<br />
OracleCommand cmd = new OracleCommand();<br />
cmd.Connection = conn;<br />
cmd.CommandText = "GET_EMPLOYEE_EMAIL";<br />
cmd.CommandType = CommandType.StoredProcedure;<br />
// add the parameters, including the return parameter to retrieve<br />
// the return value<br />
cmd.Parameters.Add("p_employee_id", OracleType.Number).Value = 101;<br />
cmd.Parameters.Add("p_email", OracleType.VarChar, 25).Direction =<br />
ParameterDirection.ReturnValue;<br />
// execute the function<br />
conn.Open();<br />
cmd.ExecuteNonQuery();<br />
conn.Close();<br />
// output the result<br />
Console.WriteLine("Email address is: " + cmd.Parameters["p_email"].Value);
</pre>
<p>控制台输出显示了员工 101 的电子邮件地址。</p>
<pre class="prettyprint linenums">Email address is: NKOCHHAR</pre>
<h4>结果集与 REF CURSOR</h4>
<p>可使用 REF CURSOR 数据类型来处理 Oracle 结果集。REF CURSOR 是一个指向 PL/SQL 查询所返回的结果集的指针。与普通的游标不同，REF CURSOR 是一个变量，它是对游标的引用，可以在执行时将其设置为指向不同的结果集。使用 REF CURSOR 输出参数可以将 Oracle 结构化程序的结果集传递回调用应用程序。通过在调用应用程序中定义 OracleType.Cursor 数据类型的输出参数，可以访问 REF CURSOR 所指向的结果集。在使用 REF CURSOR 的过程中，OracleConnection 必须保持打开状态。</p>
<h4>包</h4>
<p>PL/SQL 和 T-SQL 中的存储过程之间的一个重大差异是 PL/SQL 所使用的 Oracle 包 结构。在 T-SQL 中没有等效元素。包是在逻辑上相关的编程块（如存储过程和函数）的容器。它包含两个部分：</p>
<p>&bull;</p>
<p>规范：定义包的名称，并为包中的每个存储过程或函数提供方法签名（原型）。规范头还定义所有全局声明。规范的样式类似于 C 或 C++ 头文件。</p>
<p>&bull;</p>
<p>正文：包含包头中定义的存储过程和函数的代码。</p>
<p>每个存储过程或函数的参数都出现在括号内，并且用逗号分隔。每个参数还根据需要用以下三个标识符中的一个进行标记：</p>
<p>&bull;</p>
<p>IN：该值从调用应用程序传递到 PL/SQL 块。如果未指定标识符，则 IN 为默认传递方向。</p>
<p>&bull;</p>
<p>OUT：该值由存储过程生成，并传递回调用应用程序。</p>
<p>&bull;</p>
<p>INOUT：该值被传递到 PL/SQL 块，可能在该块内部进行修改，然后返回到调用应用程序。</p>
<p>每个参数也都被标记以指示数据类型。</p>
<p>以下包规范定义了四个过程，它们在 HR 架构的 LOCATIONS 表中创建、检索、更新和删除数据。</p>
<pre class="prettyprint linenums">CREATE OR REPLACE PACKAGE CRUD_LOCATIONS AS<br />
TYPE T_CURSOR IS REF CURSOR;<br />
PROCEDURE GetLocations (cur_Locations OUT T_CURSOR);<br />
PROCEDURE UpdateLocations (p_location_id IN NUMBER,<br />
p_street_address IN VARCHAR2,<br />
p_postal_code IN VARCHAR2,<br />
p_city IN VARCHAR2,<br />
p_state_province IN VARCHAR2,<br />
p_country_id IN CHAR);<br />
PROCEDURE DeleteLocations (p_location_id IN NUMBER);<br />
PROCEDURE InsertLocations (p_location_id OUT NUMBER,<br />
p_street_address IN VARCHAR2,<br />
p_postal_code IN VARCHAR2,<br />
p_city IN VARCHAR2,<br />
p_state_province IN VARCHAR2,<br />
p_country_id IN CHAR);<br />
END CRUD_LOCATIONS;
</pre>
<p>以下代码摘自上述包规范的包正文，说明了 GetLocations 包中的第一个过程的实现细节：</p>
<pre class="prettyprint linenums">CREATE OR REPLACE PACKAGE BODY CRUD_LOCATIONS AS<br />
PROCEDURE GetLocations (cur_Locations OUT T_CURSOR)<br />
IS<br />
BEGIN<br />
OPEN cur_Locations FOR<br />
SELECT * FROM LOCATIONS;<br />
END GetLocations;<br />
-- Implementation of other procedures ommitted.<br />
END CRUD_LOCATIONS;</pre>
<h4>使用 DataReader</h4>
<p>可以通过调用 OracleCommand 对象的 ExecuteReader() 方法来创建 OracleDataReader。本节说明如何使用 DataReader 来访问由存储过程 SELECT_JOB_HISTORY 返回的结果集。以下为包规范：</p>
<pre class="prettyprint linenums">CREATE OR REPLACE PACKAGE SELECT_JOB_HISTORY AS<br />
TYPE T_CURSOR IS REF CURSOR;<br />
PROCEDURE GetJobHistoryByEmployeeId<br />
(<br />
p_employee_id IN NUMBER,<br />
cur_JobHistory OUT T_CURSOR<br />
);<br />
END SELECT_JOB_HISTORY;
</pre>
<p>包正文定义了一个过程，该过程检索指定员工的工作经历的结果集，并将其作为 REF CURSOR 输出参数返回：</p>
<pre class="prettyprint linenums">CREATE OR REPLACE PACKAGE BODY SELECT_JOB_HISTORY AS<br />
PROCEDURE GetJobHistoryByEmployeeId<br />
(<br />
p_employee_id IN NUMBER,<br />
cur_JobHistory OUT T_CURSOR<br />
)<br />
IS<br />
BEGIN<br />
OPEN cur_JobHistory FOR<br />
SELECT * FROM JOB_HISTORY<br />
WHERE employee_id = p_employee_id;<br />
END GetJobHistoryByEmployeeId;<br />
END SELECT_JOB_HISTORY;
</pre>
<p>以下代码执行该过程，根据结果集创建 DataReader，并将 DataReader 的内容输出到控制台。</p>
<pre class="prettyprint linenums">// create connection<br />
OracleConnection conn = new OracleConnection("Data Source=oracledb;<br />
User Id=UserID;Password=Password;");<br />
// create the command for the stored procedure<br />
OracleCommand cmd = new OracleCommand();<br />
cmd.Connection = conn;<br />
cmd.CommandText = "SELECT_JOB_HISTORY.GetJobHistoryByEmployeeId";<br />
cmd.CommandType = CommandType.StoredProcedure;<br />
// add the parameters for the stored procedure including the REF CURSOR<br />
// to retrieve the result set<br />
cmd.Parameters.Add("p_employee_id", OracleType.Number).Value = 101;<br />
cmd.Parameters.Add("cur_JobHistory", OracleType.Cursor).Direction =<br />
ParameterDirection.Output;<br />
// open the connection and create the DataReader<br />
conn.Open();<br />
OracleDataReader dr = cmd.ExecuteReader();<br />
// output the results and close the connection.<br />
while(dr.Read())<br />
{<br />
for(int i = 0; i &lt; dr.FieldCount; i++)<br />
Console.Write(dr[i].ToString() + ";");<br />
Console.WriteLine();<br />
}<br />
conn.Close();
</pre>
<p>对于 HR 架构的默认安装，控制台输出显示了员工 101 的两个记录中每个记录的字段（用分号分隔）：</p>
<pre class="prettyprint linenums">101;9/21/1989 12:00:00 AM;10/27/1993 12:00:00 AM;AC_ACCOUNT;110;<br />
101;10/28/1993 12:00:00 AM;3/15/1997 12:00:00 AM;AC_MGR;110;
</pre>
<p>上述代码显示，包中的过程是使用包名称 (ELECT_JOB_HISTORY) 和过程的名称（在此情况下为 GetJobHistoryByEmployeeId）指定的，二者之间用句点分隔。</p>
<p>代码还说明了如何定义结果集的 REF CURSOR 参数。请注意，数据类型为 OracleType.Cursor，方向为 ParameterDirection.Output。</p>
<p>还请注意，在访问 REF CURSOR 中的结果集的整个过程中，连接都保持打开状态。</p>
<p>如果包返回多个游标，则 DataReader 会按照您向参数集合中添加它们的顺序来访问这些游标，而不是按照它们在过程中出现的顺序来访问。可使用 DataReader 的 NextResult() 方法前进到下一个游标。</p>
<h4>返回单个值的存储过程</h4>
<p>OracleCommand 类的 ExecuteOracleScalar() 方法用于执行将单个值作为 OracleType 数据类型返回的 SQL 语句或存储过程。如果命令返回一个结果集，则该方法会返回第一行第一列的值。如果返回了 REF CURSOR，而不是返回了 REF CURSOR 所指向的第一行第一列的值，则该方法会返回一个空引用。OracleCommand 类的 ExecuteScalar() 方法类似于 ExecuteOracleScalar() 方法，只不过它将值作为 .NET 框架数据类型返回。</p>
<p>尽管如此，在使用 Oracle 存储过程时，这两个方法都没有用。Oracle 存储过程不能将值作为 RETURN 语句的一部分返回，而只能将其作为 OUT 参数返回。有关信息，请参阅不返回数据的存储过程一节。同时，除了通过 REF CURSOR 输出参数以外，您不能返回结果集。</p>
<p>您只能使用 RETURN 参数检索 Oracle 函数的返回值（如上一节所述），而不能使用 ExecuteScalar 方法之一进行检索。</p>
<h4>序列</h4>
<p>Oracle 使用序列 来生成唯一编号，而不是使用 SQL Server 所用的数据类型 uniqueidentifier。无论是哪种情况，主要用途都是为主键列生成一系列唯一编号。与 uniqueidentifier 数据类型不同，序列是与将其用于主键值的一个或多个表无关的数据库对象。</p>
<p>Oracle 序列是原子对象，并且是一致的。也就是说，一旦您访问一个序列号，Oracle 将在处理下一个请求之前自动递增下一个编号，从而确保不会出现重复值。</p>
<p>可以使用 CREATE SEQUENCE 命令创建 Oracle 序列。该命令所带参数包括增量、起始值、最大值、循环和缓存。可使用 NEXTVAL 和 CURRVAL 关键字访问序列值。NEXTVAL 返回序列中的下一个编号，而 CURRVAL 提供对当前值的访问。HR 架构中的序列 LOCATIONS_SEQ 按如下方式定义：</p>
<pre class="prettyprint linenums">CREATE SEQUENCE LOCATIONS_SEQ<br />
INCREMENT BY 100<br />
START WITH 1<br />
MAXVALUE 9900<br />
MINVALUE 1<br />
NOCYCLE<br />
NOCACHE<br />
NOORDER
</pre>
<p>大多数序列代码是不言自明的。NOCYCLE 表示序列在达到最小值或最大值后将不再生成其他值。NOCACHE 表示序列值在被请求之前不会进行分配；可使用预分配机制来改善性能。NOORDER 表示在生成编号时，不能保证按照请求编号的顺序返回这些编号。</p>
<p>下面的代码显示了一个存储过程，该过程请求一个序列值，在向 LOCATIONS 表中插入记录时使用它设置主键值，然后在 OUT 参数中返回该主键值。</p>
<pre class="prettyprint linenums">CREATE OR REPLACE PROCEDURE ADD_LOCATION (<br />
p_location_id OUT NUMBER,<br />
p_street_address IN VARCHAR2,<br />
p_postal_code IN VARCHAR2,<br />
p_city IN VARCHAR2,<br />
p_state_province IN VARCHAR2,<br />
p_country_id IN CHAR<br />
)<br />
AS<br />
BEGIN<br />
INSERT INTO LOCATIONS (<br />
LOCATION_ID,<br />
STREET_ADDRESS,<br />
POSTAL_CODE,<br />
CITY,<br />
STATE_PROVINCE,<br />
COUNTRY_ID)<br />
VALUES (<br />
LOCATIONS_SEQ.NEXTVAL,<br />
p_street_address,<br />
p_postal_code,<br />
p_city,<br />
p_state_province,<br />
p_country_id<br />
);<br />
SELECT LOCATIONS_SEQ.CURRVAL INTO p_location_id FROM DUAL;<br />
END ADD_LOCATION;
</pre>
<p>下面的代码调用该存储过程，以插入一个记录并检索返回的序列值。</p>
<pre class="prettyprint linenums">// create the connection<br />
OracleConnection conn = new OracleConnection("Data Source=oracledb;<br />
User Id=UserID;Password=Password;");<br />
// create the command for the stored procedure<br />
OracleCommand cmd = new OracleCommand();<br />
cmd.Connection = conn;<br />
cmd.CommandText = "ADD_LOCATION";<br />
cmd.CommandType = CommandType.StoredProcedure;<br />
// add the parameters for the stored procedure including the LOCATION_ID<br />
// sequence value that is returned in the output parameter p_location_id<br />
cmd.Parameters.Add("p_location_id", OracleType.Number).Direction =<br />
ParameterDirection.Output;<br />
cmd.Parameters.Add("p_street_address", OracleType.VarChar).Value =<br />
"123 Any Street";<br />
cmd.Parameters.Add("p_postal_code", OracleType.VarChar).Value = "33040";<br />
cmd.Parameters.Add("p_city", OracleType.VarChar).Value = "Key West";<br />
cmd.Parameters.Add("p_state_province", OracleType.VarChar).Value = "FL";<br />
cmd.Parameters.Add("p_country_id", OracleType.VarChar).Value = "US";<br />
// execute the command to add the records<br />
OracleString rowId;<br />
conn.Open();<br />
int rowsAffected = cmd.ExecuteOracleNonQuery(out rowId);<br />
conn.Close();<br />
// output the results<br />
Console.WriteLine("Rows affected: " + rowsAffected);<br />
Console.WriteLine("Location ID: " +<br />
cmd.Parameters["p_location_id"].Value);
</pre>
<p>控制台显示一个记录被插入到该表中，同时还插入了该序列生成的主键值。</p>
<pre class="prettyprint linenums">Rows affected: 1<br />
Location ID: 3300</pre>
<h4>使用 DataAdapter 填充数据集</h4>
<p>可使用 REF CURSOR 通过 DataAdapter 来填充 DataSet。下面的代码利用了使用 DataReader 一节中定义的存储过程 GetJobHistoryByEmployeeId，并用它在 REF CURSOR 输出参数中返回的结果集来填充 DataSet。</p>
<p>以下是使用 DataAdapter 填充 DataSet 的代码：</p>
<pre class="prettyprint linenums">// create the connection<br />
OracleConnection conn = new OracleConnection("Data Source=oracledb;<br />
User Id=UserID;Password=Password;");<br />
// create the command for the stored procedure<br />
OracleCommand cmd = new OracleCommand();<br />
cmd.Connection = conn;<br />
cmd.CommandText = "SELECT_JOB_HISTORY.GetJobHistoryByEmployeeId";<br />
cmd.CommandType = CommandType.StoredProcedure;<br />
// add the parameters for the stored procedure including the REF CURSOR<br />
// to retrieve the result set<br />
cmd.Parameters.Add("p_employee_id", OracleType.Number).Value = 101;<br />
cmd.Parameters.Add("cur_JobHistory", OracleType.Cursor).Direction =<br />
ParameterDirection.Output;<br />
// createt the DataAdapter from the command and use it to fill the<br />
// DataSet<br />
OracleDataAdapter da = new OracleDataAdapter(cmd);<br />
DataSet ds = new DataSet();<br />
da.Fill(ds);<br />
// output the results.<br />
Console.WriteLine(ds.Tables[0].Rows.Count);
</pre>
<p>对于 HR 架构的默认安装，输出表明员工 101 有两个 JOB_HISTORY 记录。</p>
<h4>使用 DataAdapter 更新 Oracle</h4>
<p>当您使用 REF CURSOR 参数填充 DataSet 时，不能简单地使用 OracleDataAdapter 的 Update() 方法。这是因为在执行存储过程时，Oracle 不能提供确定表名和列名所需的信息。要使用 DataAdapter 的 Update() 方法，您必须创建在基础表中更新、插入和删除记录的过程。该方法类似于在 SQL Server 中使用的方法。</p>
<p>本节说明如何生成一个可以处理所需的创建、检索、更新和删除操作的包，以便能够从 Oracle 数据库中检索 LOCATION 数据，也能够将对 DataSet 数据所做的不连续更改重新更新到 Oracle 数据库。包头如下所示：</p>
<pre class="prettyprint linenums">CREATE OR REPLACE PACKAGE CRUD_LOCATIONS AS<br />
TYPE T_CURSOR IS REF CURSOR;<br />
PROCEDURE GetLocations (cur_Locations OUT T_CURSOR);<br />
PROCEDURE UpdateLocations (<br />
p_location_id IN NUMBER,<br />
p_street_address IN VARCHAR2,<br />
p_postal_code IN VARCHAR2,<br />
p_city IN VARCHAR2,<br />
p_state_province IN VARCHAR2,<br />
p_country_id IN CHAR);<br />
PROCEDURE DeleteLocations (p_location_id IN NUMBER);<br />
PROCEDURE InsertLocations (<br />
p_location_id OUT NUMBER,<br />
p_street_address IN VARCHAR2,<br />
p_postal_code IN VARCHAR2,<br />
p_city IN VARCHAR2,<br />
p_state_province IN VARCHAR2,<br />
p_country_id IN CHAR);<br />
END CRUD_LOCATIONS;
</pre>
<p>包正文如下所示：</p>
<pre class="prettyprint linenums">CREATE OR REPLACE PACKAGE BODY CRUD_LOCATIONS AS<br />
-- retrieve all LOCATION records<br />
PROCEDURE GetLocations (cur_Locations OUT T_CURSOR)<br />
IS<br />
BEGIN<br />
OPEN cur_Locations FOR<br />
SELECT * FROM LOCATIONS;<br />
END GetLocations;<br />
-- update a LOCATION record<br />
PROCEDURE UpdateLocations (<br />
p_location_id IN NUMBER,<br />
p_street_address IN VARCHAR2,<br />
p_postal_code IN VARCHAR2,<br />
p_city IN VARCHAR2,<br />
p_state_province IN VARCHAR2,<br />
p_country_id IN CHAR)<br />
IS<br />
BEGIN<br />
UPDATE LOCATIONS<br />
SET<br />
STREET_ADDRESS = p_street_address,<br />
POSTAL_CODE = p_postal_code,<br />
CITY = p_city,<br />
STATE_PROVINCE = p_state_province,<br />
COUNTRY_ID = p_country_id<br />
WHERE<br />
LOCATION_ID = p_location_id;<br />
END UpdateLocations;<br />
-- delete a LOCATION record<br />
PROCEDURE DeleteLocations (p_location_id IN NUMBER)<br />
IS<br />
BEGIN<br />
DELETE FROM LOCATIONS<br />
WHERE LOCATION_ID = p_location_id;<br />
END DeleteLocations;<br />
-- insert a LOCATION record<br />
PROCEDURE InsertLocations<br />
(<br />
p_location_id OUT NUMBER,<br />
p_street_address IN VARCHAR2,<br />
p_postal_code IN VARCHAR2,<br />
p_city IN VARCHAR2,<br />
p_state_province IN VARCHAR2,<br />
p_country_id IN CHAR<br />
)<br />
AS<br />
BEGIN<br />
INSERT INTO LOCATIONS (<br />
LOCATION_ID,<br />
STREET_ADDRESS,<br />
POSTAL_CODE,<br />
CITY,<br />
STATE_PROVINCE,<br />
COUNTRY_ID)<br />
VALUES (<br />
LOCATIONS_SEQ.NEXTVAL,<br />
p_street_address,<br />
p_postal_code,<br />
p_city,<br />
p_state_province,<br />
p_country_id<br />
);<br />
SELECT LOCATIONS_SEQ.CURRVAL INTO p_location_id FROM DUAL;<br />
END InsertLocations;<br />
END CRUD_LOCATIONS;
</pre>
<p>下面的代码定义了一个 DataAdapter，从而使用上述包中定义的过程来创建、检索、更新和删除支持 DataAdapter 的数据。DataAdapter 既可用来将数据检索到 DataSet 中，也可用来将对 DataSet 所做的更改更新到 Oracle 数据库中。</p>
<pre class="prettyprint linenums">// define the connection string<br />
String connString = "Data Source=oracledb;User Id=UserID;Password=Password;";<br />
// create the data adapter<br />
OracleDataAdapter da = new OracleDataAdapter();<br />
// define the select command for the data adapter<br />
OracleCommand selectCommand =<br />
new OracleCommand("CRUD_LOCATIONS.GetLocations",<br />
new OracleConnection(connString));<br />
selectCommand.CommandType = CommandType.StoredProcedure;<br />
selectCommand.Parameters.Add("cur_Locations",<br />
OracleType.Cursor).Direction = ParameterDirection.Output;<br />
da.SelectCommand = selectCommand;<br />
// define the udpate command for the data adapter<br />
OracleCommand updateCommand =<br />
new OracleCommand("CRUD_LOCATIONS.UpdateLocations",<br />
new OracleConnection(connString));<br />
updateCommand.CommandType = CommandType.StoredProcedure;<br />
updateCommand.Parameters.Add("p_location_id", OracleType.Number, 4,<br />
"LOCATION_ID");<br />
updateCommand.Parameters.Add("p_street_address", OracleType.VarChar, 40,<br />
"STREET_ADDRESS");<br />
updateCommand.Parameters.Add("p_postal_code", OracleType.VarChar, 12,<br />
"POSTAL_CODE");<br />
updateCommand.Parameters.Add("p_city", OracleType.VarChar, 30, "CITY");<br />
updateCommand.Parameters.Add("p_state_province", OracleType.VarChar, 25,<br />
"STATE_PROVINCE");<br />
updateCommand.Parameters.Add("p_country_id", OracleType.Char, 2,<br />
"COUNTRY_ID");<br />
da.UpdateCommand = updateCommand;<br />
// define the delete command for the data adapter<br />
OracleCommand deleteCommand =<br />
new OracleCommand("CRUD_LOCATIONS.DeleteLocations",<br />
new OracleConnection(connString));<br />
deleteCommand.CommandType = CommandType.StoredProcedure;<br />
deleteCommand.Parameters.Add("p_location_id", OracleType.Number, 4,<br />
"LOCATION_ID");<br />
da.DeleteCommand = deleteCommand;<br />
OracleCommand insertCommand =<br />
new OracleCommand("CRUD_LOCATIONS.InsertLocations",<br />
new OracleConnection(connString));<br />
insertCommand.CommandType = CommandType.StoredProcedure;<br />
insertCommand.Parameters.Add("p_location_id", OracleType.Number, 4,<br />
"LOCATION_ID");<br />
insertCommand.Parameters.Add("p_street_address", OracleType.VarChar, 40,<br />
"STREET_ADDRESS");<br />
insertCommand.Parameters.Add("p_postal_code", OracleType.VarChar, 12,<br />
"POSTAL_CODE");<br />
insertCommand.Parameters.Add("p_city", OracleType.VarChar, 30, "CITY");<br />
insertCommand.Parameters.Add("p_state_province", OracleType.VarChar, 25,<br />
"STATE_PROVINCE");<br />
insertCommand.Parameters.Add("p_country_id", OracleType.Char, 2,<br />
"COUNTRY_ID");<br />
da.InsertCommand = insertCommand;<br />
// define a DataTable and fill it using the data adapter<br />
DataTable dt = new DataTable();<br />
da.Fill(dt);<br />
// ... do work that adds, edits, updates, or deletes records in the table<br />
// call the Update() method of the data adapter to update the Oracle<br />
// database with changes made to the data<br />
da.Update(dt);</pre>
<h4>使用多个结果集</h4>
<p>Oracle 不支持批量查询，因此无法从一个命令返回多个结果集。使用存储过程时，返回多个结果集类似于返回单个结果集；必须使用 REF CURSOR 输出参数。要返回多个结果集，请使用多个 REF CURSOR 输出参数。</p>
<p>以下是返回两个结果集（全部 EMPLOYEES 和 JOBS 记录）的包规范：</p>
<pre class="prettyprint linenums">CREATE OR REPLACE PACKAGE SELECT_EMPLOYEES_JOBS AS<br />
TYPE T_CURSOR IS REF CURSOR;<br />
PROCEDURE GetEmployeesAndJobs (<br />
cur_Employees OUT T_CURSOR,<br />
cur_Jobs OUT T_CURSOR<br />
);<br />
END SELECT_EMPLOYEES_JOBS;<br />
包正文如下所示：<br />
CREATE OR REPLACE PACKAGE BODY SELECT_EMPLOYEES_JOBS AS<br />
PROCEDURE GetEmployeesAndJobs<br />
(<br />
cur_Employees OUT T_CURSOR,<br />
cur_Jobs OUT T_CURSOR<br />
)<br />
IS<br />
BEGIN<br />
-- return all EMPLOYEES records<br />
OPEN cur_Employees FOR<br />
SELECT * FROM Employees;<br />
-- return all JOBS records<br />
OPEN cur_Jobs FOR<br />
SELECT * FROM Jobs;<br />
END GetEmployeesAndJobs;<br />
END SELECT_EMPLOYEES_JOBS;
</pre>
<p>以下代码显示了如何使用从上述包中返回的两个结果集来填充 DataSet 中的两个相关表：</p>
<pre class="prettyprint linenums">// create the connection<br />
OracleConnection conn = new OracleConnection("Data Source=oracledb;<br />
User Id=UserID;Password=Password;");<br />
// define the command for the stored procedure<br />
OracleCommand cmd = new OracleCommand();<br />
cmd.Connection = conn;<br />
cmd.CommandText = "SELECT_EMPLOYEES_JOBS.GetEmployeesAndJobs";<br />
// add the parameters including the two REF CURSOR types to retrieve<br />
// the two result sets<br />
cmd.Parameters.Add("cur_Employees", OracleType.Cursor).Direction =<br />
ParameterDirection.Output;<br />
cmd.Parameters.Add("cur_Jobs", OracleType.Cursor).Direction =<br />
ParameterDirection.Output;<br />
cmd.CommandType = CommandType.StoredProcedure;<br />
// create the DataAdapter and map tables<br />
OracleDataAdapter da = new OracleDataAdapter(cmd);<br />
da.TableMappings.Add("Table", "EMPLOYEES");<br />
da.TableMappings.Add("Table1", "JOBS");<br />
// create and fill the DataSet<br />
DataSet ds = new DataSet();<br />
da.Fill(ds);<br />
// create a relation<br />
ds.Relations.Add("EMPLOYEES_JOBS_RELATION",<br />
ds.Tables["JOBS"].Columns["JOB_ID"],<br />
ds.Tables["EMPLOYEES"].Columns["JOB_ID"]);<br />
// output the second employee (zero-based array) and job title<br />
// based on the relation<br />
Console.WriteLine("Employee ID: " +<br />
ds.Tables["EMPLOYEES"].Rows[1]["EMPLOYEE_ID"] +<br />
"; Job Title: " +<br />
ds.Tables["EMPLOYEES"].Rows[1].GetParentRow(<br />
"EMPLOYEES_JOBS_RELATION")["JOB_TITLE"]);
</pre>
<p>控制台输出显示了第二个员工的职务：</p>
<pre class="prettyprint linenums">Employee ID: 101; Job Title: Administration Vice President</pre>
<h4>小结</h4>
<p>通过 Oracle .NET 数据提供程序，可以方便地执行存储过程以及访问返回值（无论返回值是一个还是多个标量值或结果集）。可以将 Oracle 过程与 OracleDataAdapter 结合使用，从而填充 DataSet、处理不连续的数据以及以后将更改更新到 Oracle 数据库。</p>
<p>Oracle 过程与 Microsoft SQL Server 存储过程之间的主要区别是：Oracle 过程必须将值作为输出参数返回，并且必须使用输出参数将结果集作为 REF CURSOR 对象返回给调用程序。</p>																
<h2>最新文章</h2>	
<ol>
						<li><a href="https://www.batexi.com/a/4qn0mmg9.html">系统升级日记（1）- 升级到SQL Server 2012</a>
		</li>
						<li><a href="https://www.batexi.com/a/g8e7lej9.html">struts2框架 初始别</a>
		</li>
						<li><a href="https://www.batexi.com/a/8e11wmm9.html">Android控件之AutoCompleteTextView（自动匹配输入的内容）</a>
		</li>
						<li><a href="https://www.batexi.com/a/8e15p2m9.html">Linux makefile 教程 很具体，且易懂</a>
		</li>
						<li><a href="https://www.batexi.com/a/qvvrl4zq.html">Python转义字符</a>
		</li>
						<li><a href="https://www.batexi.com/a/9pjg56z9.html">Cygwin解决Windows远程登录linux服务器</a>
		</li>
						<li><a href="https://www.batexi.com/a/93x315z9.html">DISCUZ&excl; X2&period;5设置仅允许QQ登录注册论坛 加固会员注册机制</a>
		</li>
						<li><a href="https://www.batexi.com/a/8mnzzz2q.html">HW4&period;40</a>
		</li>
						<li><a href="https://www.batexi.com/a/qxnvd4j8.html">linux awk浅析（转）</a>
		</li>
						<li><a href="https://www.batexi.com/a/qdpp0lzq.html">Linux 安装之U盘引导</a>
		</li>
						<li><a href="https://www.batexi.com/a/qv11wvjq.html">Chapter 3 Protecting the Data（3）：创建和使用数据库角色</a>
		</li>
						<li><a href="https://www.batexi.com/a/9rg52378.html">序列化json对象，通过ajax传入asp&period;net mvc后台</a>
		</li>
						<li><a href="https://www.batexi.com/a/q2jx1nw8.html">js 去除html标签</a>
		</li>
						<li><a href="https://www.batexi.com/a/qnj26oj8.html">systemd的命令systemctl set-property testSpeed CPUQuota&equals;10&percnt;</a>
		</li>
						<li><a href="https://www.batexi.com/a/9pwdxrd8.html">win7 升级Power Shell到4&period;0</a>
		</li>
						<li><a href="https://www.batexi.com/a/qdjeyp0q.html">Luogu 1903 数颜色 &vert; 分块</a>
		</li>
						<li><a href="https://www.batexi.com/a/qdjweljq.html">EL和OGNL表达式的区分</a>
		</li>
						<li><a href="https://www.batexi.com/a/8mj55428.html">URL重写html后Html文件打不开解决办法</a>
		</li>
						<li><a href="https://www.batexi.com/a/qlonj1eq.html">实验室项目&period;md</a>
		</li>
						<li><a href="https://www.batexi.com/a/qd5okz79.html">mac svn 命令</a>
		</li>
		</ol>
	

<h2>热门文章</h2>	
<ol>
									<li><a href="https://www.batexi.com/a/9pj25my9.html">NOIP2007 统计数字</a>
			</li>
						<li><a href="https://www.batexi.com/a/qn14ee28.html">javascript&mdash;&mdash;继承</a>
			</li>
						<li><a href="https://www.batexi.com/a/q4y311nq.html">js学习记录</a>
			</li>
						<li><a href="https://www.batexi.com/a/qxnzmwe8.html">android NDK 实用学习（三）- java端类对象的构造及使用</a>
			</li>
						<li><a href="https://www.batexi.com/a/q2wyll3q.html">HW7&period;9</a>
			</li>
						<li><a href="https://www.batexi.com/a/q4y3op0q.html">POJ2486 - Apple Tree&lpar;树形DP&rpar;</a>
			</li>
						<li><a href="https://www.batexi.com/a/8mnr5p6q.html">Mongodb 和 普通数据库 各种属性 和语句 的对应</a>
			</li>
						<li><a href="https://www.batexi.com/a/96ozryn9.html">jexus asp&period;net Linux Web Server</a>
			</li>
						<li><a href="https://www.batexi.com/a/9pj2r5z9.html">第二十章、启动流程、模块管理与 Loader grub</a>
			</li>
						<li><a href="https://www.batexi.com/a/96oz1039.html">C&num; &amp;amp&semi; SQLite - Storing Images</a>
			</li>
			</ol>			
							
					</div>

					
<div class="next-prev-posts clearfix">
</div>
						 
				</div>
				
	<div class="clear"></div>

			</div>	
			

		</div>
</div>
</div>


<div class="clearfix"></div>
<div id="footer" class="two-s-footer">
	<div class="footer-box">
		<div class="container">
			<div class="row" style="padding-left: 15px;padding-right: 15px;">
			<div class="nav-footer">
				<a href="/">Home</a>
				</div>
				<div class="copyright-footer">
					<p>Powered By WordPress</p>
				</div>
							</div>
		</div>
	</div>
</div>
<div style="display:none">

</div>
<script src="//n4.ikafan.com/assets/js/echo.js"></script>
<script>
    echo.init({
      offset: 100,
      throttle: 250,
      unload: false,
      callback: function (element, op) {
        console.log(element, 'has been', op + 'ed')
      }
    });
 </script>
</body>
</html>
